
//
//  memmap.h
//
//  This contains definitions used by the structure mapping logic that maps
//  data structures in the VAX address space into native structures.  This is
//  used for image loading, page table management, etc.
//

struct MAPLIST {
    struct MAPLIST *    next;
    char                name[ 32 ];
    LONGWORD            p_offset;
    LONGWORD            v_offset;
    short               size;
    short               kind;
};
    
struct MAP {
    struct MAP      * next;
    struct MAPLIST  *list;
    char            name[ 32 ];
};


GLOBALINIT( struct MAP * maps,  0L )


LONGWORD map_init( char * name );
LONGWORD map_add( char * name, char * member, LONGWORD vax_offset, LONGWORD struct_offset, short size, short kind );
struct MAP * find_map( char * name );
LONGWORD map_dump( void );
LONGWORD map( char * name, void * structure, ULONGWORD vax_addr );


#define STROFF( structure, member ) \
    (( LONGWORD ) &( structure-> member )) - (( LONGWORD ) structure )
